itests.sh 2.6 KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970717273747576777879808182838485868788899091929394
  1. #!/usr/bin/env bash
  2. # Function to perform cleanup
  3. cleanup() {
  4. echo "Cleaning up..."
  5. # Kill the Rust binary process
  6. echo "Killing the Rust binary with PID $RUST_BIN_PID"
  7. kill $CDK_ITEST_MINT_BIN_PID
  8. # Wait for the Rust binary to terminate
  9. wait $CDK_ITEST_MINT_BIN_PID
  10. echo "Mint binary terminated"
  11. # Kill processes
  12. lncli --lnddir="$cdk_itests/lnd" --network=regtest stop
  13. lightning-cli --regtest --lightning-dir="$cdk_itests/one/" stop
  14. lightning-cli --regtest --lightning-dir="$cdk_itests/two/" stop
  15. bitcoin-cli --datadir="$cdk_itests/bitcoin" -rpcuser=testuser -rpcpassword=testpass -rpcport=18443 stop
  16. # Remove the temporary directory
  17. rm -rf "$cdk_itests"
  18. echo "Temp directory removed: $cdk_itests"
  19. unset cdk_itests
  20. unset cdk_itests_mint_addr
  21. unset cdk_itests_mint_port
  22. }
  23. # Set up trap to call cleanup on script exit
  24. trap cleanup EXIT
  25. # Create a temporary directory
  26. export cdk_itests=$(mktemp -d)
  27. export cdk_itests_mint_addr="127.0.0.1";
  28. export cdk_itests_mint_port=8085;
  29. URL="http://$cdk_itests_mint_addr:$cdk_itests_mint_port/v1/info"
  30. # Check if the temporary directory was created successfully
  31. if [[ ! -d "$cdk_itests" ]]; then
  32. echo "Failed to create temp directory"
  33. exit 1
  34. fi
  35. echo "Temp directory created: $cdk_itests"
  36. export MINT_DATABASE="$1";
  37. cargo build -p cdk-integration-tests
  38. cargo build --bin regtest_mint
  39. cargo run --bin regtest_mint &
  40. # Capture its PID
  41. CDK_ITEST_MINT_BIN_PID=$!
  42. TIMEOUT=100
  43. START_TIME=$(date +%s)
  44. # Loop until the endpoint returns a 200 OK status or timeout is reached
  45. while true; do
  46. # Get the current time
  47. CURRENT_TIME=$(date +%s)
  48. # Calculate the elapsed time
  49. ELAPSED_TIME=$((CURRENT_TIME - START_TIME))
  50. # Check if the elapsed time exceeds the timeout
  51. if [ $ELAPSED_TIME -ge $TIMEOUT ]; then
  52. echo "Timeout of $TIMEOUT seconds reached. Exiting..."
  53. exit 1
  54. fi
  55. # Make a request to the endpoint and capture the HTTP status code
  56. HTTP_STATUS=$(curl -o /dev/null -s -w "%{http_code}" $URL)
  57. # Check if the HTTP status is 200 OK
  58. if [ "$HTTP_STATUS" -eq 200 ]; then
  59. echo "Received 200 OK from $URL"
  60. break
  61. else
  62. echo "Waiting for 200 OK response, current status: $HTTP_STATUS"
  63. sleep 2 # Wait for 2 seconds before retrying
  64. fi
  65. done
  66. # Run cargo test
  67. cargo test -p cdk-integration-tests --test regtest
  68. # Run cargo test with the http_subscription feature
  69. cargo test -p cdk-integration-tests --test regtest --features http_subscription
  70. # Capture the exit status of cargo test
  71. test_status=$?
  72. # Exit with the status of the tests
  73. exit $test_status